<?php

include "settings.php";


$pieces_file .= ".css";
$board_file .= ".css";

$rank = array(0 => "8", 1 => "7", 2 => "6", 3 => "5", 4 => "4", 5 => "3", 6 => "2", 7 => "1");
$file = array(0 => "a", 1 => "b", 2 => "c", 3 => "d", 4 => "e", 5 => "f", 6 => "g", 7 => "h");

$rank_inv = array("8" => 0, "7" => 1, "6" => 2, "5" => 3, "4" => 4, "3" => 5, "2" => 6, "1" => 7);
$file_inv = array("a" => 0, "b" => 1, "c" => 2, "d" => 3, "e" => 4, "f" => 5, "g" => 6, "g" => 8);

$valuation = array("p" => 1, "n" => 3, "b" => 3, "r" => 5, "q" => 9);

$move = $_POST['move'];

/*$from = $_POST['from'];
$to = $_POST['to'];*/

$move = explode(":",$move);

$from = &$move[0];
$to = &$move[1];

$fen = $_GET['fen'];
if (isset($_POST['fen']))
	$fen = $_POST['fen'];

if (empty($fen))
	$fen = "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1";
$fenraw = $fen;
$fen = explode(" ",$fen);
$board = explode("/",$fen[0]);
$turn = &$fen[1];
$castle = &$fen[2];
$en_passant = &$fen[3];
$half_clock = &$fen[4];
$full_clock = &$fen[5];


if (isset($to) && $turn == "w")
	$turn = "b";
elseif (isset($to) && $turn == "b")
	$turn = "w";

if ((isset($_GET['flip'])) && ($flip_state == "0")){
	setcookie("fenipulator-flip","1",time()+31536000);
	$flip_state = "1";
	}
elseif ((isset($_GET['flip'])) && ($flip_state == "1")){
	setcookie("fenipulator-flip","0",time()+31536000);
	$flip_state = "0";
	}

if (isset($_GET['summ'])){
	setcookie("fenipulator-summ","1",time()+31536000);
	$summary = "1";
	}


function space_color($row, $col){
	if ($row%2 == $col%2)
		$color = "light";
	else
		$color = "dark";
	return $color;
	}


function fix_spaces($row) {
	for ($i=0; $i<strlen($row); $i++){
		if ((substr($row,$i,1) != " ") && $count == 0){
			$newrow .= substr($row,$i,1);			
			}
		elseif ((substr($row,$i,1) != " ") && $count > 0){
			$newrow .= $count .= substr($row,$i,1);
			$count = 0;
			}
		else
			$count++;		
		}
		if ($count > 0)
			$newrow .= $count;
		return $newrow;
	}

function fen_to_spaces($row_fen){
	for ($i=0; $i<strlen($row_fen); $i++){
		$current_pos = substr($row_fen,$i,1);
		if (is_numeric($current_pos)){
			for ($j=0; $j<$current_pos; $j++)
				$row .= " ";
			}
		else
			$row .= $current_pos;
		}
	return $row;
	}

function can_castle(){
	global $turn, $castle;
	if (($turn == "w" && (str_replace("K","",$castle) != $castle || str_replace("Q","",$castle) != $castle)))
		return true;
	elseif (($turn == "b" && (str_replace("k","",$castle) != $castle || str_replace("q","",$castle) != $castle)))
		return true;
	else
		return false;
	}

function gen_board_from_move ($board, $from, $to){
	global $half_clock, $fen, $castle, $en_passant, $promote_to;
	$from = explode(",",$from);
	$to = explode(",",$to);
	$active = substr(fen_to_spaces($board[$from[0]]),$from[1],1);
	$destination = substr(fen_to_spaces($board[$to[0]]),$to[1],1);
	/*castling*/
	if (($from[0]==0) && ($from[1]==0) && ($active=="r"))
		$castle = str_replace("q","",$castle);
	elseif (($from[0]==0) && ($from[1]==7) && ($active=="r"))
		$castle = str_replace("k","",$castle);
	elseif (($from[0]==7) && ($from[1]==0) && ($active=="R"))
		$castle = str_replace("Q","",$castle);
	elseif (($from[0]==7) && ($from[1]==7) && ($active=="R"))
		$castle = str_replace("K","",$castle);
	elseif (($from[0]==0) && ($active=="k")){
		if (($to[0]==0) && ($to[1]==2) && (str_replace("q","",$castle) != $castle)){
			for ($i=0; $i<$from[1]; $i++){
				if (substr(fen_to_spaces($board[0]),$i,1) == "r")
					$rook = $i;
				}
			$board = gen_board_from_move($board, "0,$rook", "0,3");
			}
		elseif (($to[0]==0) && ($to[1]==6) && (str_replace("k","",$castle) != $castle)){
			for ($i=7; $i>$from[1]; $i--){
				if (substr(fen_to_spaces($board[0]),$i,1) == "r")
					$rook = $i;
				}
			$board = gen_board_from_move($board, "0,$rook", "0,5");
			}
		$castle = str_replace("q","",$castle);
		$castle = str_replace("k","",$castle);
		}
	elseif (($from[0]==7) && ($active=="K")){
		if (($to[0]==7) && ($to[1]==2) && (str_replace("Q","",$castle) != $castle)){
			for ($i=0; $i<$from[1]; $i++){
				if (substr(fen_to_spaces($board[7]),$i,1) == "R")
					$rook = $i;
				}
			$board = gen_board_from_move($board, "7,$rook", "7,3");
			}
		elseif (($to[0]==7) && ($to[1]==6) && (str_replace("K","",$castle) != $castle)){
			for ($i=7; $i>$from[1]; $i--){
				if (substr(fen_to_spaces($board[7]),$i,1) == "R")
					$rook = $i;
				}
			$board = gen_board_from_move($board, "7,$rook", "7,5");
			}
		$castle = str_replace("Q","",$castle);
		$castle = str_replace("K","",$castle);
		}
	if ($castle == "")
		$castle = "-";

	/*pawn promotion*/
	if (($to[0] == 7) && ($active=="p"))
		$active = $promote_to;
	elseif (($to[0] == 0) && ($active=="P"))
		$active = strtoupper($promote_to);
	
	$prev_en_passant = $en_passant;
	$en_passant = "-";

	/*en passant*/
	if (($from[0] == 1) && ($to[0]==3) && ($from[1] == $to[1]) && ($active="p")){
		$en_target[0] = 2;
		$en_target[1] = $to[1];
		$en_passant = pos_to_san($en_target);
	}
	elseif (($from[0] == 6) && ($to[0]==4) && ($from[1] == $to[1]) && ($active="P")){
		$en_target[0] = 5;
		$en_target[1] = $to[1];
		$en_passant = pos_to_san($en_target);
	}
	elseif (($prev_en_passant != "-") && ($prev_en_passant == pos_to_san($to)) && (strtolower($active) == "p")){
		if ($active == "p")
			$en_target[0] = 2;
		else
			$en_target[0] = 5;
		$en_target[1] = $to[1];
		/*
		$new_en_row = fen_to_spaces($board[$en_target[0]]);
		$new_en_row[$en_target[1]] = " ";
		$new_en_row = fix_spaces($new_en_row);
		$board[$en_target[0]] = $new_en_row;
		*/
		}

	$new_from_row = fen_to_spaces($board[$from[0]]);
	if (!(($active=="K") && substr($new_from_row,$from[1],1)=="R") && !(($active=="k" && substr($new_from_row,$from[1],1)=="r")))
		$new_from_row[$from[1]] = " ";
	if (isset($en_target))
		$new_from_row[$en_target[1]] = " ";
	$new_from_row = fix_spaces($new_from_row);
	$board[$from[0]] = $new_from_row;

	$new_to_row = fen_to_spaces($board[$to[0]]);
	$new_to_row[$to[1]] = $active;
	$new_to_row = fix_spaces($new_to_row);
	

	
	$board[$to[0]] = $new_to_row;

	if ($destination != " ")
		$half_clock = 0;
	elseif (strtolower($active) == "p")
		$half_clock = 0;
	else
		$half_clock++;

	return $board;

	}

function pos_to_san($pos){
	global $rank, $file;
	$san = $file[$pos[1]] . $rank[$pos[0]];
	return $san;
	}

function san_to_pos($san){
	global $rank_inv, $file_inv;
	$pos[0] = $rank_inv[substr($san, 1, 1)];
	$pos[1] = $file_inv[substr($san, 0, 1)];
	return $pos;
	}

if (!empty($from) && !empty($to))
	$board = gen_board_from_move($board, $from, $to);

function is_active($row,$col){
	global $from, $to;
	$from_exp = explode(",",$from);
	$to_exp = explode(",",$to);
	if (((!empty($from)) && ($from_exp[0] == $row) && ($from_exp[1] == $col)) || (!empty($to)) && ($to_exp[0] == $row) && ($to_exp[1] == $col))
		$active = "active";
	else
		$active = "inactive";
	return $active;
	}

function gen_board_from_fen(){
global $board, $from, $to, $fenraw, $turn, $rank, $w_valuation, $b_valuation, $valuation;
/*echo "<div id='debug'>" . $from . "</div>";*/
$from_exp = explode(",",$from);
if (!empty($from))
	$from_piece = substr(fen_to_spaces($board[$from_exp[0]]),$from_exp[1],1);
$row .= "<form action='" . $site . "index.php?fen=" . urlencode($fenraw) . "' method='post'>";
for ($i=0; $i<=7; $i++){
	$pos = 0;
	$row .= "<span class='rank turn'>" . $rank[$i] . "</span>";
	for ($j=0; $j<strlen($board[$i]); $j++){
		 
		$cur_pos = substr($board[$i],$j,1);

		if (is_numeric($cur_pos)){
			for ($k=0; $k<$cur_pos; $k++){
				$active = is_active($i,$pos);
				if (!empty($from) && empty($to))
					$row .= "<button name='move' value='$from:$i,$pos'><span class='space empty " . space_color($i,$pos) . "'></span></button>";
				else
					$row .= "<span class='space empty " . $active . " " . space_color($i,$pos) . "'></span>";		
				$pos++;
				
				}
			}
		else{
			$active = is_active($i,$pos);
			$piece = "<span class='space piece turn " . $active . " " . $cur_pos . " " . space_color($i,$pos) . "'></span>";

			if (strtoupper($cur_pos) == $cur_pos){
				$cur_color = "w";
				$w_valuation += $valuation[strtolower($cur_pos)];
			}
			else{
				$cur_color = "b";
				$b_valuation += $valuation[$cur_pos];
			}

			if (empty($from) && $cur_color == $turn)
				$row .= "<button name='move' value='$i,$pos'>" . $piece . "</button>";
			elseif (empty($from) && $cur_color != $turn)
				$row .= $piece;
			elseif (!empty($from) && $cur_color == $turn && !(can_castle() && strtolower($from_piece) == "k" && ((strtolower($cur_pos) == "r" || strtolower($cur_pos) == "k"))))
				$row .= $piece;
			elseif (!empty($to))
				$row .= $piece;
			else
				$row .= "<button name='move' value='$from:$i,$pos'>" . $piece . "</button>";
		
			$pos++;
			}
		}
		$row .= "<br />";
	}
$row .= "</form>";
echo $row;
return $row;
}

function gen_fen_from_board($board, $fen, $turn){
	$board = implode("/",$board);
	$fen[0] = $board;
	$fen[1] = $turn;
	return $fen;
	}

function flip_flipper(){
	$flip .= $_SERVER['REQUEST_URI'];
	if (empty($_GET['flip']) && (isset($_GET['fen']) || isset($_GET['summ'])))
		$flip .= "&flip=true";
	elseif (empty($_GET['flip']) && empty($_GET['fen']))
		$flip .= "?flip=true";
	return $flip;
	}

function summary_flipper(){
	$summflip .= $_SERVER['REQUEST_URI'];
	if (isset($_GET['fen']) || isset($_GET['flip']))
		$summflip .= "&summ=true";
	else
		$summflip .= "?summ=true";
	return $summflip;
	}

function summary_disabler(){
	global $summary;
	if ($summary == "1")
		$output = "<style type='text/css'>#header-summary{display:none;}</style>";
	echo $output;
	}

function flip_handler(){
	global $flip_state;
	if ($flip_state == "1")
		echo "<style type='text/css'> .turn{-webkit-transform: rotate(180deg); -moz-transform: rotate(180deg); -o-transform: rotate(180deg); -ms-transform: rotate(180deg);} </style>";
	}

function gen_status_box(){
	global $fen, $board, $turn, $fenraw, $half_clock, $full_clock, $castle, $en_passant, $to, $w_valuation, $b_valuation;
	$oldfen = $fenraw;
	$fen = gen_fen_from_board($board, $fen, $turn);
	if ($turn == "w" && !empty($to))
		$full_clock++;
	$fen[4] = $half_clock;
	$fen[5] = $full_clock;
	$fenraw = implode(" ",$fen);
	/*if (empty($_GET['fen']))*/
	$output .= "Input FEN here and press enter:<br />";
	$output .= "<form action='index.php' method='post'><input type='text' name='fen' value='$fenraw' autofocus='autofocus' /><input type='submit' /></form>";
	if ($turn == "w"){
		$output .= "White's turn.<br />";
		if (str_replace("K","",$castle) != $castle)
			$output .= "White can castle kingside.<br />";
		if (str_replace("Q","",$castle) != $castle)
			$output .= "White can castle queenside.<br />";
		if ($en_passant != "-")
			$output .= "Black is vulnerable to an en passant attack at " . $en_passant . ".<br />";
		}	
	elseif ($turn == "b"){
		$output .= "Black's turn.<br />";
		if (str_replace("k","",$castle) != $castle)
			$output .= "Black can castle kingside.<br />";
		if (str_replace("q","",$castle) != $castle)
			$output .= "Black can castle queenside.<br />";
		if ($en_passant != "-")
			$output .= "White is vulnerable to an en passant attack at " . $en_passant . ".<br />";
		}
	$output .= "Halfmoves: " . $half_clock . ", ";
	$output .= "Fullmoves: " . $full_clock . "<br />";
	$output .= "Simple piece valuation of white: " . $w_valuation . ", black: " . $b_valuation . "<br />";
	$output .= "<ul><li><a href='" . $site . "index.php?fen=" . urlencode($fenraw) . "'>Link to current board state</a></li><li><a href='" . $site . "index.php?fen=" . urlencode($oldfen) . "'>Reset turn</a></li><li><a href='" . flip_flipper() . "'>Flip board</a></li></ul><br />"; 
	echo $output;
	}
?>

<?php ob_start(); ?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<link rel="stylesheet" href="<?php echo $style_file; ?>" type="text/css" />
<link rel="stylesheet" href="<?php echo $site . "pieces/" . $pieces_file; ?>" type="text/css" />
<link rel="stylesheet" href="<?php echo $site . "boards/" . $board_file; ?>" type="text/css" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

<?php flip_handler(); ?>
<?php summary_disabler(); ?>

<title>fenipulator • <?php echo $fenraw; ?></title>
</head>
<body>

<div id="header">
<h2><b>fen</b>ipulator</h2>
<span id="header-summary">fenipulator, by <a href="http://brhfl.com">brian hefele</a>, is an extremely simple chess board application. i call it a chess <i>board</i> application, and not a <i>chess</i> application, because it has no validation or knowledge of the rules of the game, it does not keep track of games, it does not track check/mate, &amp;c. it really only keeps track of <a href="http://en.wikipedia.org/wiki/Forsyth%E2%80%93Edwards_Notation">fen</a> data. it takes in fen, renders a board, allows the player to make a move, and then generates new fen. <b>basic play is as follows:</b> click to select a piece. click elsewhere to move the piece. to confirm your move, copy the link under 'link to current board state,' and paste that to your opponent. your opponent will then click this link, and do the same. <a href="<?php echo summary_flipper(); ?>">hide summary.</a></span>
<div id="header-menu">
<ul>
	<li><a href="http://brhfl.com/fenipulator/">about</a></li>
	<li><a href="<?php echo $site;?>index.php">new board</a></li>
	<li><a href="<?php echo $site;?>960.php">new 960</a></li>
	<li><a href="<?php echo $site;?>options.php?fen=<?php echo urlencode($fenraw);?>">options</a></li>
	<!--
	<li><a href="http://fenipulator.brhfl.com/version-history.txt">version history</a></li>
	<li><a href="http://fenipulator.brhfl.com/fenipulator-1.4.zip">download latest</a></li>
	-->
</ul>
</div>
</div>

<div id="board" class="turn">
<?php gen_board_from_fen();?>
<span class="file turn corner">a</span>
<span class="file turn">b</span>
<span class="file turn">c</span>
<span class="file turn">d</span>
<span class="file turn">e</span>
<span class="file turn">f</span>
<span class="file turn">g</span>
<span class="file turn">h</span>

</div>

<div id="status">
<?php gen_status_box();?>
</div>

</body>

</html>


